/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    Combined SIL module
    module aio-test
    revision 2020-02-20
    namespace http://yumaworks.com/ns/aio-test
    CLI parameters:
        format c
        indent 4
        log-level debug3
        module aio-test
        output aio-test.c
        sil-edit2
        sil-get2
        unified true

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_action.h"
#include "agt_cb.h"
#include "agt_cfg.h"
#include "agt_rpc.h"
#include "agt_sil_lib.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "agt_val.h"
#include "cfg.h"
#include "dlq.h"
#include "getcb.h"
#include "ncx.h"
#include "ncx_feature.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "obj.h"
#include "rpc.h"
#include "status.h"
#include "val.h"
#include "val_child.h"
#include "val_util.h"
#include "xml_val.h"
#include "aio-test.h"

/* module static variables */
static ncx_module_t *aio_test_mod;
static obj_template_t *get3_config_cont_obj;
static obj_template_t *get3_state_cont_obj;
static val_value_t *get3_config_cont_val;

/* put your static variables here */

/********************************************************************
* FUNCTION y_aio_test_init_static_vars
*
* initialize module static variables
*
********************************************************************/
static void y_aio_test_init_static_vars (void)
{
    aio_test_mod = NULL;
    get3_config_cont_obj = NULL;
    get3_state_cont_obj = NULL;
    get3_config_cont_val = NULL;

    /* init your static variables here */

} /* y_aio_test_init_static_vars */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get
*
* Get database object callback for list nonconfig-list2
* Path: list /get3-config-cont/config-list/nonconfig-list/nonconfig-list2
* Fill in 'get2cb' response fields
*
* sil-aio-get2 extension enabled for this object;
* No callbacks for children will be called
*
* XML encoded buffer is expected
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get (
        ses_cb_t *scb,
        xml_msg_hdr_t *msg,
        getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get");
    }

    (void)scb;
    (void)msg;

#if 0

    /* Use the ancestor and local keys if needed */

    val_value_t *keyval = NULL;

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_name = 0;
    keyval = GETCB_GET2_FIRST_KEY(get2cb);
    if (keyval) {
        k_get3_config_cont_config_list_name = VAL_STRING(keyval);
    }

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_name = 0;
    keyval = GETCB_GET2_NEXT_KEY(get2cb, keyval);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_name = VAL_STRING(keyval);
    }

    /* local key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_name = 0;
    boolean name_fixed = FALSE;
    boolean name_present = FALSE;
    keyval = getcb_find_key_lvl(get2cb,
        y_aio_test_M_aio_test,
        y_aio_test_N_name,
        (uint32)5);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_name = VAL_STRING(keyval);
        name_fixed = VAL_IS_FIXED_VALUE(keyval);
        name_present = TRUE;
    }

    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
#endif

    status_t res = NO_ERR;

    /* make XML buffer that will be used instead of return val value
     * NOTE if the callback target is a list, the XML buffer must provide
     * parent node in the buffer. There cannot be multiple siblings
     * in XML, it will make XML malformed.
     *
     * If the list is a top level node use the following wrapper:
     * <config xmlns=\"http://netconfcentral.org/ns/yuma-ncx\"></config>
     */
    const xmlChar *xml_buffer = (const xmlChar *)
        "<nonconfig-list xmlns=\"http://yumaworks.com/ns/aio-test\">"
        "<nonconfig-list2>"
        "<name>name1</name><nonconfig-list3>"
        "<name>name1</name></nonconfig-list3><nonconfig-list3>"
        "<name>name2</name></nonconfig-list3></nonconfig-list2>"
        "<nonconfig-list2>"
        "<name>name2</name><nonconfig-list3>"
        "<name>name1</name></nonconfig-list3><nonconfig-list3>"
        "<name>name2</name></nonconfig-list3></nonconfig-list2>"
        "<nonconfig-list2>"
        "<name>name3</name><nonconfig-list3>"
        "<name>name1</name></nonconfig-list3><nonconfig-list3>"
        "<name>name2</name></nonconfig-list3></nonconfig-list2>"
        "</nonconfig-list>";

    /* Add created buffer to return get2cb */
    res = getcb_add_return_aio_buff(get2cb, xml_buffer);

    return res;

} /* aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_nonconfig_list_get
*
* Get database object callback for list nonconfig-list
* Path: list /get3-config-cont/config-list/nonconfig-list
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_nonconfig_list_get (ses_cb_t *scb,
                                                              xml_msg_hdr_t *msg,
                                                              getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_config_list_nonconfig_list_get");
    }

    (void)scb;
    (void)msg;

#if 0
    /* Use the ancestor and local keys if needed */

    val_value_t *keyval = NULL;

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_name = 0;
    keyval = GETCB_GET2_FIRST_KEY(get2cb);
    if (keyval) {
        k_get3_config_cont_config_list_name = VAL_STRING(keyval);
    }

    /* local key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_name = 0;
    boolean name_fixed = FALSE;
    boolean name_present = FALSE;
    keyval = getcb_find_key_lvl(get2cb,
        y_aio_test_M_aio_test,
        y_aio_test_N_name,
        (uint32)4);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_name = VAL_STRING(keyval);
        name_fixed = VAL_IS_FIXED_VALUE(keyval);
        name_present = TRUE;
    }
#endif

    boolean getnext = FALSE;

    /* check the callback mode type */
    getcb_mode_t cbmode = GETCB_GET2_CBMODE(get2cb);
    switch (cbmode) {
    case GETCB_GET_VALUE:
        break;
    case GETCB_GETNEXT_VALUE:
        getnext = TRUE;
        break;
    default:
        return SET_ERROR(ERR_INTERNAL_VAL);
    }

    /* get the list and child objects */
    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
    obj_template_t *name_obj =
        obj_find_child(obj,
                      y_aio_test_M_aio_test,
                      (const xmlChar *)"name");

    /* init leaf values for the get2-list */
    const xmlChar *name = NULL;
    const xmlChar *ret_name = NULL;
    boolean name_fixed = FALSE;

    /* check the keyQ for the specific list instance requested */
    val_value_t *name_key = getcb_find_key(get2cb, name_obj);

    /* pretend there are 3 values  */
#define NAME1 (const xmlChar *)"name1"
#define NAME2 (const xmlChar *)"name2"
#define NAME3 (const xmlChar *)"name3"

    if (name_key && VAL_STR(name_key)) {
        name = VAL_STR(name_key);
        int32 ret = xml_strcmp(name, NAME3);
        if (ret > 0) {
            return ERR_NCX_NO_INSTANCE;
        }
        name_fixed = VAL_IS_FIXED_VALUE(name_key);
    }

    boolean moreflag = TRUE;

    /* check validity of keys present */
    if (getnext) {
        if (name_fixed) {
            return ERR_NCX_NO_INSTANCE;
        }

        /* adjust the key to find the next entry after
         * the specified value
         */
        if (!name) {
            ret_name = NAME1; // return first entry [0]
        } else {
            /* find the correct entry to retrieve */
            int32 ret = xml_strcmp(name, NAME1);
            if (ret < 0) {
                ret_name = NAME1;
            } else if (ret == 0) {
                ret_name = NAME2;
            } else {
                /* check NAME2 */
                ret = xml_strcmp(name, NAME2);
                if (ret < 0) {
                    ret_name = NAME2;
                } else if (ret == 0) {
                    ret_name = NAME3;
                    moreflag = FALSE;
                } else {
                    /* assume NAME3 */
                    ret_name = NAME3;
                    moreflag = FALSE;
                }
            }
        }
    } else {
        if (name) {
            /* get a specified instance */
            boolean name_ok = FALSE;
            if (!xml_strcmp(name, NAME1)) {
                name_ok = TRUE;
            } else if (!xml_strcmp(name, NAME2)) {
                name_ok = TRUE;
            } else if (!xml_strcmp(name, NAME3)) {
                name_ok = TRUE;
                moreflag = FALSE;
            }
            if (name_ok) {
                ret_name = name;
            } else {
                return ERR_NCX_NO_INSTANCE;
            }
        } else {
            // else no keys == get-first
            ret_name = NAME1;
        }
    }

    GETCB_GET2_MATCH_TEST_DONE(get2cb) = FALSE;
    GETCB_GET2_MORE_DATA(get2cb) = moreflag;

    status_t res = NO_ERR;

    /* if we get here then the index is valid
     *
     * create a return_keyQ node for the name key value
     */
    val_value_t *return_val =
        agt_make_leaf2(obj,
                       y_aio_test_M_aio_test,
                       (const xmlChar *)"name",
                       ret_name,
                       &res);
    if (return_val && res == NO_ERR) {
        getcb_add_return_key(get2cb, return_val);
    } else {
        return res;
    }

    return res;

} /* aio_test_get3_config_cont_config_list_nonconfig_list_get */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_edit
*
* Edit database object callback
* Path: list /get3-config-cont/config-list
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_edit (ses_cb_t *scb,
                                                rpc_msg_t *msg,
                                                agt_cbtyp_t cbtyp,
                                                op_editop_t editop,
                                                val_value_t *newval,
                                                val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_config_list_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }
        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* aio_test_get3_config_cont_config_list_edit */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_edit
*
* Edit database object callback
* Path: container /get3-config-cont
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_edit (ses_cb_t *scb,
                                    rpc_msg_t *msg,
                                    agt_cbtyp_t cbtyp,
                                    op_editop_t editop,
                                    val_value_t *newval,
                                    val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }

        if (res == NO_ERR) {
            res = agt_check_cache(&get3_config_cont_val, newval, curval, editop);
        }

        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* aio_test_get3_config_cont_edit */


/********************************************************************
* FUNCTION aio_test_get3_state_cont_get
*
* Get database object callback for container get3-state-cont
* Path: container /get3-state-cont
* Fill in 'get2cb' response fields
*
* sil-aio-get2 extension enabled for this object;
* No callbacks for children will be called
*
* JSON encoded buffer is expected
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_state_cont_get (ses_cb_t *scb,
                                  xml_msg_hdr_t *msg,
                                  getcb_get2_t *get2cb)
{
    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_state_cont_get");
    }

    (void)scb;
    (void)msg;

    status_t res = NO_ERR;

    /* make JSON buffer that will be used instead of return val value */
    const xmlChar *json_buffer = (const xmlChar *)
        "{\"aio-test:get3-state-cont\":{\"D\":42,\"C2\":\"someleaf\"}}";;

    /* Add created buffer to return get2cb */
    res = getcb_add_return_aio_buff(get2cb, json_buffer);

    return res;

} /* aio_test_get3_state_cont_get */


/********************************************************************
* FUNCTION y_aio_test_init
*
* initialize the aio-test server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
status_t
    y_aio_test_init (const xmlChar *modname,
                     const xmlChar *revision)
{
    status_t res = NO_ERR;

    y_aio_test_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_aio_test_M_aio_test)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && xml_strcmp(revision, y_aio_test_R_aio_test)) {
        return ERR_NCX_WRONG_VERSION;
    }

    res =
        ncxmod_load_module(y_aio_test_M_aio_test,
                           y_aio_test_R_aio_test,
                           agt_get_savedevQ(),
                           &aio_test_mod);
    if (res != NO_ERR) {
        return res;
    }

    get3_config_cont_obj =
        ncx_find_object(aio_test_mod,
                        y_aio_test_N_get3_config_cont);
    if (get3_config_cont_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    get3_state_cont_obj =
        ncx_find_object(aio_test_mod,
                        y_aio_test_N_get3_state_cont);
    if (get3_state_cont_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    res =
        agt_cb_register_edit2_callback(y_aio_test_M_aio_test,
                                       (const xmlChar *)"/aiotest:get3-config-cont",
                                       y_aio_test_R_aio_test,
                                       aio_test_get3_config_cont_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_edit2_callback(y_aio_test_M_aio_test,
                    (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list",
                                       y_aio_test_R_aio_test,
                                       aio_test_get3_config_cont_config_list_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_get_callback(y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list",
                                     y_aio_test_R_aio_test,
                                     aio_test_get3_config_cont_config_list_nonconfig_list_get);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_get_callback(y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list/aiotest:nonconfig-list2",
                                     y_aio_test_R_aio_test,
                        aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_get_callback(y_aio_test_M_aio_test,
                                     (const xmlChar *)"/aiotest:get3-state-cont",
                                     y_aio_test_R_aio_test,
                                     aio_test_get3_state_cont_get);
    if (res != NO_ERR) {
        return res;
    }

    /* put your module initialization code here */

    return res;

} /* y_aio_test_init */


/********************************************************************
* FUNCTION y_aio_test_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
status_t y_aio_test_init2 (void)
{
    status_t res = NO_ERR;

    get3_config_cont_val =
        agt_init_cache(y_aio_test_M_aio_test,
                       y_aio_test_N_get3_config_cont,
                       &res);
    if (res != NO_ERR) {
        return res;
    }

    /* put your init2 code here */

    return res;

} /* y_aio_test_init2 */


/********************************************************************
* FUNCTION y_aio_test_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
void y_aio_test_cleanup (void)
{

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list/aiotest:nonconfig-list2");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-state-cont");

    /* put your cleanup code here */

} /* y_aio_test_cleanup */

/* END SIL aio_test.c */
